## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 7;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1
# Build a C-API shared library with cargo-c and install it?
#
# Once we build a shared library in an EPEL release, we are almost guaranteed
# to eventually need to maintain a ccompat package to preserve its API/ABI
# stability. For the time being, we don’t plan to ship a shared library in any
# EPEL release unless someone specifically asks for it.
%bcond capi %{expr:%{undefined fc40} && %{undefined fc41} && %{undefined epel}}

%global crate libcramjam

Name:           rust-libcramjam
# Even though this is just MAJOR.MINOR from the SemVer version, we repeat it
# explicitly to help prevent undetected/unannounced SONAME version bumps in the
# libcramjam/libcramjam-devel subpackages.
%global soversion 0.7
Version:        0.7.0
Release:        %autorelease
Summary:        Compression library combining a plethora of algorithms

License:        MIT
URL:            https://crates.io/crates/libcramjam
Source:         %{crates_source}
# Manually created patch for downstream crate metadata changes
# * Add crate-type = ["lib", "cdylib"] to the [lib] table to get a better
#   template from rust2rpm
# * Do not upper-bound the version of libdeflate-sys (which is only due to CI
#   limitations)
# * Patch out all -static features
# * Patch out features requiring blosc2-rs or isal-rs so we can stop packaging
#   those crates
# * Drop unused direct cbindgen build-dependency:
#   https://github.com/cramjam/libcramjam/pull/23
# * Relax bzip2 dependency to allow building with both v0.4 and v0.5:
#   https://github.com/cramjam/libcramjam/pull/24
Patch:          libcramjam-fix-metadata.diff

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  cargo-c

%global _description %{expand:
Compression library combining a plethora of algorithms in a similar as
possible API.}

%description %{_description}

%if %{with capi}
%package     -n %{crate}
Summary:        %{summary}
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# BSD-3-Clause
# BSD-3-Clause AND MIT
# MIT
# MIT OR Apache-2.0
# MIT OR Zlib OR Apache-2.0
License:        %{shrink:
                (0BSD OR MIT OR Apache-2.0) AND
                Apache-2.0 AND
                BSD-3-Clause AND
                MIT AND
                (MIT OR Apache-2.0) AND
                (MIT OR Zlib OR Apache-2.0)
                }
# LICENSE.dependencies contains a full license breakdown

%description -n %{crate} %{_description}

This package contains libraries for using the "%{crate}" crate via a C API.

%files       -n %{crate}
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%{_libdir}/%{crate}.so.%{soversion}{,.*}

%package     -n %{crate}-devel
Summary:        %{summary}

Requires:       %{crate}%{?_isa} = %{version}-%{release}

%description -n %{crate}-devel %{_description}

This package contains libraries and header files for developing applications
that use the "%{crate}" crate via a C API.

%files       -n %{crate}-devel
%{_includedir}/cramjam/cramjam.h
%{_libdir}/%{crate}.so
%{_libdir}/pkgconfig/%{crate}.pc
%else
%global debug_package %{nil}
%endif

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+brotli-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+brotli-devel %{_description}

This package contains library source intended for building other packages which
use the "brotli" feature of the "%{crate}" crate.

%files       -n %{name}+brotli-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+bzip2-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+bzip2-devel %{_description}

This package contains library source intended for building other packages which
use the "bzip2" feature of the "%{crate}" crate.

%files       -n %{name}+bzip2-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+capi-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+capi-devel %{_description}

This package contains library source intended for building other packages which
use the "capi" feature of the "%{crate}" crate.

%files       -n %{name}+capi-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+deflate-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+deflate-devel %{_description}

This package contains library source intended for building other packages which
use the "deflate" feature of the "%{crate}" crate.

%files       -n %{name}+deflate-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+deflate-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+deflate-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "deflate-shared" feature of the "%{crate}" crate.

%files       -n %{name}+deflate-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+gzip-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+gzip-devel %{_description}

This package contains library source intended for building other packages which
use the "gzip" feature of the "%{crate}" crate.

%files       -n %{name}+gzip-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+gzip-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+gzip-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "gzip-shared" feature of the "%{crate}" crate.

%files       -n %{name}+gzip-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+lz4-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+lz4-devel %{_description}

This package contains library source intended for building other packages which
use the "lz4" feature of the "%{crate}" crate.

%files       -n %{name}+lz4-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+snappy-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+snappy-devel %{_description}

This package contains library source intended for building other packages which
use the "snappy" feature of the "%{crate}" crate.

%files       -n %{name}+snappy-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+xz-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+xz-devel %{_description}

This package contains library source intended for building other packages which
use the "xz" feature of the "%{crate}" crate.

%files       -n %{name}+xz-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+xz-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+xz-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "xz-shared" feature of the "%{crate}" crate.

%files       -n %{name}+xz-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zlib-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zlib-devel %{_description}

This package contains library source intended for building other packages which
use the "zlib" feature of the "%{crate}" crate.

%files       -n %{name}+zlib-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zlib-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zlib-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "zlib-shared" feature of the "%{crate}" crate.

%files       -n %{name}+zlib-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zstd-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zstd-devel %{_description}

This package contains library source intended for building other packages which
use the "zstd" feature of the "%{crate}" crate.

%files       -n %{name}+zstd-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires -a

%build
%cargo_build -a
%{cargo_license_summary -a}
%{cargo_license -a} > LICENSE.dependencies
%if %{with capi}
%cargo_cbuild -a
%endif

%install
%cargo_install -a
%if %{with capi}
%cargo_cinstall -a
# https://docs.fedoraproject.org/en-US/packaging-guidelines/#packaging-static-libraries
rm '%{buildroot}%{_libdir}/%{crate}.a'
%endif

%if %{with check}
%check
%cargo_test -a
%endif

%changelog
## START: Generated by rpmautospec
* Fri Mar 21 2025 Fabio Valentini <decathorpe@gmail.com> - 0.7.0-7
- Relax bzip2 dependency to allow building with both v0.4 and v0.5

* Mon Mar 10 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.0-6
- Add upstream status for the patch to drop cbindgen

* Sun Mar 09 2025 Fabio Valentini <decathorpe@gmail.com> - 0.7.0-5
- Drop unused direct cbindgen build-dependency

* Sun Jan 19 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Wed Jan 15 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.0-3
- Don’t build shared libraries in EPEL, to avoid supporting them

* Mon Jan 13 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.0-1
- Update to 0.7.0 (close RHBZ#2337404)
- Patch out optional features that would require blosc2-rs or isal-rs
  crates

* Wed Jan 08 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.6.0-3
- Report and skip tests that segfault with blosc2-2.15.2

* Fri Dec 27 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.6.0-2
- Update to cbindgen 0.27

* Mon Dec 09 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.6.0-1
- Update to 0.6.0 (close RHBZ#2277635)

* Tue Nov 26 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-11
- Remove Fedora-39 conditionals, since it has reached end of life

* Wed Oct 02 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-10
- Update brotli to 7.x

* Wed Oct 02 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-9
- Bump release number to preserve upgrade path from F41

* Tue Oct 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-8
- F41+: Drop i686 support (leaf package on that architecture)

* Mon Sep 30 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-7
- Update brotli from 3.x to 6.x

* Wed Aug 07 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-6
- Rebuilt with latest crate dependencies

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sat Jul 06 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-4
- Do not test a hard-coded expected compressed data size

* Thu May 23 2024 Fabio Valentini <decathorpe@gmail.com> - 0.3.0-3
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Tue May 21 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-2
- Drop conditionals for Fedora 38 since it is EOL

* Sat Mar 16 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.3.0-1
- Update to 0.3.0 (close RHBZ#2268667)

* Sun Mar 10 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2.0-2
- Use rust2rpm 26 features to reduce the amount of manual packaging work
- Fix tests that assume C char is signed

* Sat Feb 03 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2.0-1
- Update to 0.2.0 (close RHBZ#2262481)

* Wed Jan 31 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.5-1
- Initial package (close RHBZ#2257076)
## END: Generated by rpmautospec
